<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2008 *
 * ===============                              Last change: 09/28/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : refback_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Functions for refback extension                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer Refback-Erweiterung              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Payback refback for refid and reduce it for current user
function ADD_REFBACK_POINTS ($uid, $ref, $points, $ref_points) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	// Back ref depths
	$GLOBALS['cache_array']['depth'][$uid][$ref] = $GLOBALS['ref_level'];

	// Init points
	$return = $points;

	// Get all ref levels
	$result_refs = SQL_QUERY("SELECT level, percents FROM `{!_MYSQL_PREFIX!}_refdepths` WHERE level > 0 ORDER BY level ASC",
	__FUNCTION__, __LINE__);

	// "Walk" through all level
	while ($content = SQL_FETCHARRAY($result_refs)) {
		// Reset ref depths
		unset($GLOBALS['ref_level']);

		// "Walk" through all refids
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},ref={$ref},level={$content['level']},points={$points}<br />\n";
		foreach (GET_REFBACK_USERID_ARRAY($uid, $content['level']) as $refid) {
			// Skip level zero or if both are the same
			if ($uid == $refid) continue;

			// Get refback percents
			$percents = GET_REFBACK_PERCENTS($uid, $refid);
			//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},ref={$ref},refid={$refid},points={$points},percents={$percents}<br />\n";

			// Some percents given?
			if ($percents > 0) {
				//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):points={$points},perc={$content['percents']},percents={$percents},level={$content['level']}<br />\n";
				// Calculate points for refback
				$refback = $points * ($content['percents'] / 100) * ($percents / 100);

				// Update refback table ("refid" and "uid" must be exchanged!)
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_refs` SET points=points+%s WHERE userid=%s AND refid=%s LIMIT 1",
				array($refback, $refid, $uid), __FUNCTION__, __LINE__);
				//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):refback={$refback},uid={$uid},refid={$refid} - UPDATE! (".SQL_AFFECTEDROWS().")<br />\n";

				// Add points again, but only directly
				//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):refback={$refback}<br />\n";
				ADD_POINTS_REFSYSTEM_DIRECT(sprintf("refback:%s", $refid), $uid, $refback);

				// Reduce points if refid is found
				if ($refid == $ref) {
					// Reduce points here!
					$return = $points * ($content['percents'] / 100) - $refback;
					//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):points={$return} - REDUCED<br />\n";
				} // END - if
			} // END - if
		} // END foreach
	} // END - while

	// Free result
	SQL_FREERESULT($result_refs);

	// Restore ref depth
	$GLOBALS['ref_level'] = $GLOBALS['cache_array']['depth'][$uid][$ref];

	// Return them
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
	return $return;
}

// "Getter" for refback percents
function GET_REFBACK_PERCENTS ($uid, $ref) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},ref={$ref}<br />\n";
	// Skip identical ids
	if ($uid == $ref) return 0;

	// Default is zero
	$percents = 0;

	// Get percents from database
	$result = SQL_QUERY_ESC("SELECT refback FROM `{!_MYSQL_PREFIX!}_user_refs` WHERE userid=%s AND refid=%s LIMIT 1",
	array($ref, $uid), __FUNCTION__, __LINE__);

	// Entry found? (Should be!)
	if (SQL_NUMROWS($result) == 1) {
		// Fetch percents
		list($percents) = SQL_FETCHROW($result);
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):percents={$percents}<br />\n";
	} else {
		// Debug log
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>): NO ENTRY FOUND! :-(<br />\n";
		DEBUG_LOG(__FUNCTION__, __LINE__, " uid={$uid},ref={$ref} - No entry found! :-(");
	}

	// Free result
	SQL_FREERESULT($result);

	// Return percents
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
	return $percents;
}

// "Getter" for userid array which will return only one entry
function GET_REFBACK_USERID_ARRAY ($rid, $level) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):rid={$rid},level={$level}<br />\n";
	// Init userids
	$userIds = array();

	// Look for all
	$result = SQL_QUERY_ESC("SELECT userid
FROM `{!_MYSQL_PREFIX!}_user_refs`
WHERE refid=%s AND level=%s
ORDER BY userid ASC",
	array($rid,$level), __FUNCTION__, __LINE__);

	// Entries found?
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):numRows=".SQL_NUMROWS($result)."<br />\n";
	if (SQL_NUMROWS($result) > 0) {
		// Add all
		while ($content = SQL_FETCHARRAY($result)) {
			//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):rid={$rid},level={$level},userid={$content['userid']}<br />\n";
			$userIds[] = $content['userid'];
		} // END - while
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return array
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):rid={$rid},count()=".count($userIds)."<br />\n";
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
	return $userIds;
}

// Update "refback table"
function updateRefbackTable ($uid) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	// Make it sure referal level zero (member him-/herself) is at least selected
	if (empty($GLOBALS['cache_array']['back_level'])) $GLOBALS['cache_array']['back_level'] = 1;
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level={$GLOBALS['cache_array']['back_level']}<br />\n";

	// Init refid
	$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']] = 0;
	$old = 0; $minus = 0;

	// Check for his referal
	$result_refid = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE refid=%s ORDER BY userid ASC",
	array(bigintval($uid)), __FUNCTION__, __LINE__);

	// When no entry was updated then we have to create it here
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):found=".SQL_NUMROWS($result_refid)."<br />\n";
	if (SQL_NUMROWS($result_refid) > 0) {
		// Load all refids
		while (list($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]) = SQL_FETCHROW($result_refid)) {
			// Remmber userid
			$GLOBALS['cache_array']['up_userid'][$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]] = $uid;

			//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]}<br />\n";
			// Refid set?
			if (($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']] > 0) && ($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']] != $uid) && (isset($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]))) {
				// New userid?
				if ((isset($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']-1])) && (isset($GLOBALS['cache_array']['up_userid'][$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']-1]]))) {
					// New userid!
					$old = $uid;
					$uid = $GLOBALS['cache_array']['up_userid'][$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']-1]];
					$minus = 1;
					//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},old={$old},level={$GLOBALS['cache_array']['back_level']},ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]} - NEW UID!<br />\n";
				} // END - if

				// Check existence
				$result = SQL_QUERY_ESC("SELECT `id` FROM `{!_MYSQL_PREFIX!}_user_refs` WHERE userid=%s AND level='%s' AND refid=%s LIMIT 1",
				array(bigintval($uid), $GLOBALS['cache_array']['back_level'], bigintval($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']])), __FUNCTION__, __LINE__);

				// Do we have no entry?
				//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level={$GLOBALS['cache_array']['back_level']},ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]},minus={$minus},numRows=".SQL_NUMROWS($result)." - FOUND!<br />\n";
				if (SQL_NUMROWS($result) == 0) {
					// Insert this level
					//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level={$GLOBALS['cache_array']['back_level']},ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]} - ADD!<br />\n";
					SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_user_refs` (userid,level,refid) VALUES (%s,%s,%s)",
					array(bigintval($uid), $GLOBALS['cache_array']['back_level'], bigintval($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']])), __FUNCTION__, __LINE__);

					// Move to next referal level and count his counter one up!
					$GLOBALS['cache_array']['back_level']++; updateRefbackTable($GLOBALS['cache_array']['up_refid'][($GLOBALS['cache_array']['back_level'] - 1)]);
				} // END - if

				// Do we have another level here?
				if ((($GLOBALS['cache_array']['back_level']-$minus) > 0) && ($old > 0)) {
					// Restore old one
					$uid = $old;

					// Shall we add this as well?
					$result = SQL_QUERY_ESC("SELECT `id` FROM `{!_MYSQL_PREFIX!}_user_refs` WHERE userid=%s AND level='%s' AND refid=%s LIMIT 1",
					array(bigintval($uid), ($GLOBALS['cache_array']['back_level']-$minus), bigintval($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']])), __FUNCTION__, __LINE__);

					// Do we have no entry?
					//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level=".($GLOBALS['cache_array']['back_level']-$minus).",ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]},numRows=".SQL_NUMROWS($result)." - BACK!<br />\n";
					if (SQL_NUMROWS($result) == 0) {
						// Insert this level
						SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_user_refs` (userid,level,refid) VALUES (%s,%s,%s)",
						array(bigintval($uid), ($GLOBALS['cache_array']['back_level']-$minus), bigintval($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']])), __FUNCTION__, __LINE__);
						//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level=".($GLOBALS['cache_array']['back_level']-$minus).",ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]} - RETURNED!<br />\n";
					} // END - if
				} // END - if
			} // END - if
		} // END - while

		// Free memory
		SQL_FREERESULT($result_refid);
	} // END - if

	// When he has a referal...
	if ((($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']] == $uid) || ($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']] == 0)) && (GET_EXT_VERSION('cache') >= '0.1.2') && (!isset($GLOBALS['cache_array']['back_cached']))) {
		// Remove cache here
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']]} - CACHE!<br />\n";
		if ($GLOBALS['cache_instance']->loadCacheFile('refback')) $GLOBALS['cache_instance']->destroyCacheFile();
		$GLOBALS['cache_array']['back_cached'] = 1;
	} // END - if

	// "Walk" back here
	$GLOBALS['cache_array']['back_level']--;
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level={$GLOBALS['cache_array']['back_level']} - LEVEL!<br />\n";

	// Fix empty refid
	if (!isset($GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']-1])) $GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']-1] = 0;
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):uid={$uid},level={$GLOBALS['cache_array']['back_level']},ref={$GLOBALS['cache_array']['up_refid'][$GLOBALS['cache_array']['back_level']-1]} - BACK!<br />\n";
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
}

// "Getter" for array for user refs in given level
function GET_USER_REFS ($uid, $level) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	// Default is no refs and no nickname
	$add = '';
	$refs = array();

	// Do we have nickname extension installed?
	if (EXT_IS_ACTIVE('nickname')) {
		$add = ", d.nickname";
	} // END - if

	// Get refs from database
	$result = SQL_QUERY_ESC("SELECT r.id, r.refid, r.refback, r.points, d.status".$add."
FROM `{!_MYSQL_PREFIX!}_user_refs` AS r
LEFT JOIN `{!_MYSQL_PREFIX!}_user_data` AS d
ON r.refid=d.userid
WHERE r.userid=%s AND r.level=%s
ORDER BY r.refid ASC",
	array(bigintval($uid), bigintval($level)), __FUNCTION__, __LINE__);

	// Are there some entries?
	if (SQL_NUMROWS($result) > 0) {
		// Fetch all entries
		while ($row = SQL_FETCHARRAY($result)) {
			// Add row
			$refs[$row['id']] = $row;
		} // END - while
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return result
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
	return $refs;
}

// "Getter" for refback entry
function GET_USER_REF_ENTRY ($id) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	// Default data is nothing
	$data = array();

	// Secure id number
	$id = bigintval($id);

	// Get entry from database
	$result = SQL_QUERY_ESC("SELECT id, refid, refback, level FROM `{!_MYSQL_PREFIX!}_user_refs` WHERE `id`=%s AND `userid`=%s LIMIT 1",
	array($id, getUserId()), __FUNCTION__, __LINE__);

	// Is there an entry?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch data
		$data = SQL_FETCHARRAY($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return entry
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
	return $data;
}

// Update refback percents (but with some sanity-checks!
function REFBACK_CHANGE_MEMBER_PERCENTS ($id, $percents) {
	//* DEBUG: */ print "----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n";
	// Default status is failed
	$status['message'] = getMessage('MEMBER_REFBACK_ERROR_GENERAL');

	// Do some sanity-checks
	if (!IS_MEMBER()) {
		// No member!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_NO_MEMBER');
		return $status;
	} elseif ("".$id."" != ''.($id + 0)."") {
		// No number!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_INVALID_ID_NUMBER');
		return $status;
	} elseif (($percents < 0) || ($percents > 100)) {
		// Percentage is not valid!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_INVALID_PERCENTAGE');
		return $status;
	}

	// Get ref entry
	$dummy = GET_USER_REF_ENTRY($id);

	// Is this valid?
	if (count($dummy) == 0) {
		// ID does not belong to user!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_ID_MISMATCH');
		return $status;
	} // END - if

	// Revert german commata
	$percents = convertCommaToDot($percents);

	// Update entry
	SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_refs` SET refback='%s' WHERE `id`=%s AND `userid`=%s LIMIT 1",
	array($percents, $id, getUserId()), __FUNCTION__, __LINE__);

	// Entry updated?
	if (SQL_AFFECTEDROWS() < 1) {
		// Entry not updated!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_NOT_UPDATED');
		return $status;
	} // END - if

	// Prepare email content
	$content = array(
		'percents' => translateComma($percents),
		'refid'    => $dummy['refid'],
		'level'    => $dummy['level']
	);

	// Load member email template
	$mail = LOAD_EMAIL_TEMPLATE("member_refback", $content, getUserId());

	// Send email to user
	sendEmail($dummy['refid'], getMessage('MEMBER_REFBACK_SUBJECT'), $mail);

	// Send admin notification
	sendAdminNotification(getMessage('ADMIN_REFBACK_SUBJECT'), "admin_refback", $content, getUserId());

	// All fine!
	$status['ok'] = true;

	// Return status array
	//* DEBUG: */ print "</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />\n";
	return $status;
}
//
?>
